var distancetable = new Array();
  
function ed_min (a, b, c) {
  var min = (a < b) ? a : b;
  return (min < c) ? min : c;
}

function distance (word1, word2) {
  var d = new Array();
  var len_word1;	// length of s
  var len_word2;	// length of t
  var i;		// iterates through word1
  var j;		// iterates through word2
  var word1_i;		// ith character of s
  var word2_j;		// jth character of t
  var cost;		// cost

  len_word1 = word1.length;
  len_word2 = word2.length;

  if (len_word1 == 0) return len_word2;
  if (len_word2 == 0) return len_word1;

  // the new 2D table
  for (i = 0; i <= len_word1; i++) d[i] = new Array();
   
  // initialize the first row and the first column
  for (i = 0; i <= len_word1; i++) d[i][0] = i;
  for (j = 0; j <= len_word2; j++) d[0][j] = j;

  // fill in the rest of cells
  for (i = 1; i <= len_word1; i++) {
    word1_i = word1.charAt (i - 1);
    for (j = 1; j <= len_word2; j++) {
      word2_j = word2.charAt(j - 1);
      cost = (word1_i == word2_j)? 0:1;
      d[i][j] = ed_min (d[i-1][j]+1, d[i][j-1]+1, d[i-1][j-1] + cost);
    }
  }

  // pass back to the global variable distancetable
  for(i=1; i<=len_word1; i++)  {
    distancetable[i] = new Array();
    for(j=1; j<=len_word2; j++) distancetable[i][j] = d[i][j];
  }
  return d[len_word1][len_word2];
}
  
function ed_DrawTable() {
  var word1 = document.ed_form.ed_word1.value;
  var word2 = document.ed_form.ed_word2.value;
  var n = word1.length;
  var m = word2.length;
  var i,j;

  distance(word1,word2);
  table = "<table border=\"0\" cellpadding=\"4\" cellspacinging=\"0\">";

  for(i=0; i<=m+1; i++) {
    table += "<tr bgcolor=lightblue>";
    for(j=0; j<=n+1; j++) {
      if (i>1 && j>1) {
        table += "<td id=" + i + "-" + j + " align=center>";
        if (i==(m+1) && j==(n+1)) {
          table += "<font color=\"red\"><b>";
        }
        table += distancetable[j-1][i-1];
      } else {
      table += "<td align=center>";
      }

      if(i==1 && j>0) table += (j-1);
      if(j==1 && i>1) table += (i-1);
     
      if(i==0 && j>1) {
        table += "<font color=blue size=5>" + word1.charAt(j-2) + "</font>";
      } else {
        if(j==0 && i>1) {
          table += "<font color=blue size=5>" + word2.charAt(i-2) + "</font>";
        } else {
          if(j==0 && i==0) table += "";
        }
      }
      table += "</td>";
    }
    table += "</tr>";
  }
   
  table += "</table>";
   
  if(document.getElementById) {
    document.getElementById('ed_result').innerHTML = table;
  } else {
    newwindow=window.open("","distance","width=400,height=500,scrollbars=yes");
    newwindow.document.write(table);
  }
}
